Subject: bug#20395: 24.3; Documentation for `replace-regexp-in-string'

From: Eli Zaretskii <[email-masked]>
Date: Tue, 21 Apr 2015 18:00:01 +0300

> From: Eli Barzilay <[email-masked]>
> Date: Tue, 21 Apr 2015 05:59:01 -0400
> 
>     When REP is called, the match data are the result of matching
>     REGEXP against a substring of STRING.
> 
> and IMO that "a substring" is very subtle and easy to miss.  I then
> looked at the code, and at least in its current form, I saw that I
> could do this instead:
> 
>     (let ((text "foo\nbar\nbaz\n") (r "*"))
>       (replace-regexp-in-string
>        "\n\\(.\\)"
>        (lambda (s) (concat "\n" r (match-string 1 s)))
>        text))
> 
> So I think that it would be really good if this was made explicit in
> the documentation, better with an example.  Something like
> 
>     When REP is called, the match data are the result of matching
>     REGEXP against only the currently matched substring of STRING.
>     For example, (lambda (s) (concat "<" (match-string 1 s) ">")) as
>     REP is equivalent to "<\\1>".

Thanks.

However, I wonder whether your suggested change is really enough of an
improvement.  AFAIU, the main problem with the existing doc string is
that it doesn't explain _which_ substring is being alluded to here, it
only hints on the answer.  And your suggested change also leaves that
part unexplained, leaving it to the reader to glean that from the fact
that 'concat' is being used.

So I think it would be good to come up with text that actually makes
that part clear.  WDYT?